//Ksztette:    Kling Attila
//Dtum:         2009.02.16.

//Feladat:       20. llaptsuk meg, hogy egy vektoban betnknt elhelyezett szveg
//                   odafel olvasva ugyanaz-e, mint visszafel olvasva!
//
//Bemen adatok: vector<string> t	- karakterek tmbje
//Kimen adatok: ostream l	- l logikai vltoz true rtke, ha acronyma, false egybknt.
//Tevkenysg:	 A tmb feltltse billentyzetrl,
//               majd az akronym tulajdonsg vizsglata.
#include <iostream>
#include <fstream>
#include <vector>

using namespace std;

int InputEllenor(const string& msg);
void beolvas(vector<char> &t, int &n);
void beolvasfilebol(char filename[20],vector<char> &t,int &n);
bool megold(const vector<char> &t, const int n);

// --- Main ---
int main()
{
    int n;
    char ch,ch2;
    char filename[20];
    vector<char> t;
    cout << "Ez a program billentyuzetrol beker egy szot, es eldonti rola, hogy ugyanaz-e odafele olvasva, mint visszafele.\n\n";

    do {
            cout << "[F]ile v. [K]onzol? "; cin >> ch2;
    // Fileblolvass
            if((ch2 == 'f') || (ch2 == 'F')){
                beolvasfilebol(filename,t,n);
            }
    // Konzolrl
            else if((ch2 == 'k') || (ch2 == 'K')){
                beolvas(t,n);
            }
            else{
                cout << "Csak File, vagy Konzol!\n"; break;
            }
    // Eredmny
        if(megold(t,n)){
            cout << "Tukorszo.\n";
        }
        else{
            cout << "Nem tukorszo!\n";
        }

    // jrafuttats
    cout << "Futtasam ujra? (I/N)";
    cin >> ch;
    }while(ch!='n' && ch!='N');
    return 0;
}
// --- Fggvnyek ---
int InputEllenor(const string& msg)
{
    int n;
    bool hiba;
    do{
        cout << msg;
        string str;
        cin >> str;
        n = atoi(str.c_str());
        hiba = n==0 && str!="0" || n<=0;
       if(hiba) cout << "Termeszetes szamot kell megadni!" << endl;
    }while(hiba);
    return n;
}

void beolvasfilebol(char filename[20],vector<char> &t,int &n)
{
    cout << "Adja meg az input file nevet! ";
    cin >> filename; cout << endl;

    ifstream input(filename, ios::in);

    if(input.fail()){
        cout << "Hibas fajlnev! [e - exit]"<< endl;
        char ch; cin >> ch;
        exit(1);
    }

    input >> n;

    t.resize(n);
    for(int i=0; i<n; ++i){
        input >> t[i];
    }

   /* if(t.size()) // ha nem res a file
    {
        input >> n;
        t.resize(n);
        for(int i=0; i<n; ++i){
            input >> t[i];
        }
    }
    else  // ha res
    {
        cout << "Hiba, ures file!";
        exit(1);
    }*/

    input.close();

    for(int i=0; i<n; ++i){
        cout << t[i];
    }
    cout << endl;
}

void beolvas(vector<char> &t, int &n)
{
    n = InputEllenor("Add meg a szo hosszat: ");
    cout << "Add meg a szot: ";
    t.resize(n);
    for(int i=0; i<(char) t.size(); ++i)
    {
        cin >> t[i];
    }
}

bool megold(const vector<char> &t, const int n)
{
    bool l = true;
    int i=0;
    while(l && i<=(n-i))
    {
        if(t[i] != t[(n-1)-i])
        {
            l = false;
        }
        ++i;
    }
    return l;
}

